#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Longer city tours (solution)
# 
# Solutions to the bigger examples for the challenge: find the shortest path through a set of streets.

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')
import matplotlib.pyplot as plt
plt.style.use("ggplot")


# In[2]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Level 1

# In[3]:


from ensae_projects.datainc.data_geo_streets import get_seattle_streets, shapely_records
from ensae_projects.datainc.data_geo_streets import seattle_streets_set_small, folium_html_street_map

name = get_seattle_streets()
shapes, records, fields = shapely_records(name)
edges_index, edges, vertices, distances = seattle_streets_set_small(shapes, records)
folium_html_street_map(edges_index, shapes, html_width="50%", zoom_start=15)


# In[4]:


from ensae_projects.datainc.data_geo_streets import plot_streets_network
plot_streets_network(edges_index, edges, vertices, shapes, figsize=(10,10));


# In[5]:


from ensae_projects.challenge.city_tour import best_euler_path
couples, solution, distance = best_euler_path(edges_index=edges_index, edges=edges,
                                              distances=distances, vertices=vertices, fLOG=print)
"distance", distance


# In[6]:


from ensae_projects.challenge.city_tour import euler_path
plot_streets_network(edges_index, edges, vertices, shapes, order=solution, figsize=(10,10));


# ## Level 2

# In[7]:


from ensae_projects.datainc.data_geo_streets import seattle_streets_set_level2
edges_index, edges, vertices, distances = seattle_streets_set_level2(shapes, records)
folium_html_street_map(edges_index, shapes, html_width="80%", zoom_start=14)


# In[8]:


from ensae_projects.challenge.city_tour import best_euler_path
couples, solution, distance = best_euler_path(edges_index=edges_index, edges=edges,
                                              distances=distances, vertices=vertices, fLOG=print)
"distance", distance


# In[9]:


from ensae_projects.challenge.city_tour import euler_path
plot_streets_network(edges_index, edges, vertices, shapes, order=solution, figsize=(20,20));


# ## Level 3

# In[10]:


from ensae_projects.datainc.data_geo_streets import seattle_streets_set_level3
edges_index, edges, vertices, distances = seattle_streets_set_level3(shapes, records)
# We skip display as it takes some time
# folium_html_street_map(edges_index, shapes, html_width="80%", zoom_start=14)


# In[11]:


from ensae_projects.challenge.city_tour import best_euler_path
if False:
    # Be prepared, it is quite long, the bellman implementation has to be improved.
    couples, solution, distance = best_euler_path(edges_index=edges_index, edges=edges,
                                                  distances=distances, vertices=vertices, fLOG=print)
    "distance", distance


# In[12]: